#include	"extern_dmonitor.h"

char	*node_OnOff (char flg)
{
	if (flg) return "ON ";
	return "OFF";
}

void    PICinfo (void)
{
	char	pic_buff[32];
        int     ret;
        int     i;
	char	status;
	char	mode;
	char	mode2;
	unsigned char	delay;

        syslog (LOG_INFO, "NODE PIC version: ");
        ret = 8;
        while (ret == 8)
        {
                ret = usb_control_msg(udev, 0xC0, GET_VERSION, 0, 0, pic_buff, 8, 200);
		pic_buff[ret] = 0x00;
                syslog (LOG_INFO, "%s", pic_buff);
        }
        ret = usb_control_msg(udev, 0xC0, GET_USERID, 0, 0, pic_buff, 8, 200);
        if (ret == 8)
        {
                pic_buff[8] = 0x20;
                for (i = 0 ; i < 8 ; i++)
                {
                        if (pic_buff[i] == 0x20)
                        {
                                pic_buff[i] = '.';
				pic_buff[i+1] = 0x00;
                                break;
                        }
                }
                syslog (LOG_INFO, "NODE This PIC program is licensed to %s", 
			pic_buff);
        }

        ret = usb_control_msg(udev, 0xC0, GET_SERIAL_NO, 0, 0, pic_buff, 8, 200);
        if (ret == 8)
        {
                pic_buff[8] = 0x20;
                for (i = 7 ; i > 0 ; i--)
                {
                        if (pic_buff[i] != 0x20)
                        {
                                pic_buff[i+1] = '.';
				pic_buff[i+2] = 0x00;
                                break;
                        }
                }
                syslog (LOG_INFO, "NODE Serial Number :  %s", pic_buff);
        }

	usb_control_msg(udev, 0xC0, GET_DelayTime, 0, 0, (char *)&delay, 1, 100);
	syslog (LOG_INFO, "NODE Delay time %d mSec.", delay*10);

	usb_control_msg(udev, 0xC0, GET_INVERT_STATUS, 0, 0, &status, 1, 100);
	syslog (LOG_INFO, "NODE TX Invert %3.3s", node_OnOff(status & TX_INV));
	syslog (LOG_INFO, "NODE RX Invert %3.3s", node_OnOff(status & RX_INV));
	syslog (LOG_INFO, "NODE Auto RX Invert %3.3s", node_OnOff(status & AutoRXDetect));
	usb_control_msg(udev, 0xC0, GET_MODE, 0, 0, &mode, 1, 100);
	syslog (LOG_INFO, "NODE CRC Check %3.3s", node_OnOff(mode & CRC_SW));
	syslog (LOG_INFO, "NODE COS Check %3.3s", node_OnOff(mode & COS_SW));
	usb_control_msg(udev, 0xC0, GET_MODE2, 0, 0, &mode2, 1, 100);
	syslog (LOG_INFO, "NODE Header Gen. %3.3s", node_OnOff(mode2 & HeaderGen));
	syslog (LOG_INFO, "NODE Alter Header %3.3s", node_OnOff(mode2 & AlterHeader));

}

