#include	<stdio.h>
#include	<sys/types.h>
#include	<sys/socket.h>
#include	<netinet/in.h>
#include	<string.h>
#include	<sys/time.h>
#include	<unistd.h>
#include	<stdlib.h>
#include	<sys/utsname.h>
#include	<signal.h>
#include	<sys/select.h>
#include	<netinet/tcp.h>
#include	<netinet/in.h>
#include	<arpa/inet.h>
#include	<errno.h>
#include	<netdb.h>
#include	<time.h>
#include	<ctype.h>
#include	<fcntl.h>
#include	<termios.h>
#include	<linux/tty.h>
#include	<sys/ioctl.h>
#include	<net/if.h>
#include	<sys/select.h>
#include	<syslog.h>
#include	<sys/stat.h>
#include	<wiringPi.h>
#include	<lcd.h>
#include	<openssl/md5.h>
#include	<usb.h>
#include	"dstar.h"
#include	"node.h"
#include	"config.h"

#define		_DEBUG_DVAP
//#define		_DEBUG_DVMEGA
//#define		_SPECIFICATIO_CHECK
#define		_DEBUG_DVAP_SEND
#define		_DEBUG_DVAP_RECV
//#define		_DEBUG_DVAP_SQUELCH
//#define		_DEBUG_JITTER
//#define		_DEBUG_INET

#define		GW	0x80
#define		ZR	0x40
#define		FWD	0x04
#define		XCHANGE	0x08


#define		HOLE_PUNCHD_SERVER	"hole-punchd.d-star.info"
#define		HOLE_PUNCHD_PORT	30010

#define		KEEP_ALIVE_INTERVAL	2

#define		CONNECTED_LIST		"/var/tmp/connected_table.html"	
#define         CONNECTED_LIST_TEMP     "/var/tmp/connected_table.temp"	
#define		ERROR_MSG		"/var/tmp/error_msg.html"
#define		ERROR_TEMP		"/var/tmp/error_msg.tmp"
#define		SHORT_MSG		"/var/tmp/short_msg.html"
#define		SHORT_TEMP		"/var/tmp/short_msg.tmp"
#define		BUFF_HOLD		"/var/www/buff_hold.txt"
#define		DVAP_CONF		"/var/www/dvap.conf"
#define		DVMEGA_CONF		"/var/www/dvmega.conf"
#define         NODE_CONF         	"/var/www/node.conf"
#define		RIG_DEVICE		"/dev/dstar"
#define		DMONITOR_FILE		"/var/www/dmonitor.conf"
#define		IDxxPlus_SPEED  	B38400
#define         DVAP_SPEED      	B230400
#define		DVMEGA_SPEED		B115200

#define		RIG_LED		19
#define		INET_LED	26

#define		PID_FILE		"/var/run/dmonitor.pid"

#define		SRC_INET_PORT	51000

#define		HOLE_PUNCH_SEND_INTERVAL 	2

#define		OS_RELEASE	"/etc/os-release"
#define		CODENAME	"buster"

void	drop_rate_print (void);
void	rig_fifo_check (void);

int	sig_term;

sigset_t	save_sig;
sigset_t	sigset;

fd_set	read_set;
fd_set	fd_save;

time_t	start_time;
time_t	cur_time;
struct	timespec	timeout;

struct	sockaddr_in	in_addr;
int	in_addr_sock;

struct	sockaddr_in	out_addr;

int	rig_fd;
struct	termios	save_attr;
struct	termios	attr;

time_t	send_time;

time_t	rig_alive_recv;

int	rig_buff_pnt;
int	rig_buff_next;

int	dest_inet_port;
char	*dest_address;
char	inet_send_buff[58];
int	m_seq;
int	frameID;
char	area_call[8];
char	zone_call[8];
int	send_sw;

int	hole_punch_port;
char	hole_punch_server[128];

unsigned char	inet_frame_id[2];
unsigned char	inet_frame_id_save[2];
struct	timeval	inet_recv_time;
struct	timeval	inet_recv_time_save;
struct	timeval	inet_recv_timeout;

struct	timeval		rig_last_timeout;
int	seq;
unsigned char send_buff[128];

unsigned char	inet_posit_buff[26];

time_t	rig_init_time;
int	scan_sw;
int	no_daemon;
struct	timeval	inet_time;
struct	timeval c_time;

struct  timeval rig_send_time;

char	header_save[42];

int	rig_send_sw;
int	LastFrameID;

FILE	*status_fd;

struct  FifoPkt
{
        struct  FifoPkt *next;
        int     length;
        unsigned char pkt[1024];
};

struct  FifoPkt *Rp;
struct  FifoPkt *Wp;
int     Fifo_cnt;
unsigned char recv_frame_seq;
int	fifo_hold;
int	fifo_new_hold;
int	rig_last_frame_send;

int	inet_led_sw;
int	rig_led_sw;

time_t	hole_punch_send_time;
int     hole_punch_send_cnt;
int	hole_punch_send_interval;

char	connect_call[8];

FILE	*connected_fd;

int	error_msg_sw;

unsigned int	inet_m;
unsigned int	inet_m_save;

long int	inet_read_cnt;
long int	inet_read_drop_cnt;

long int	jitter_max;
long int	jitter_min;
long int	jitter_ave;

unsigned char	jitter_buff[21][13];
int		jitter_rd_pnt;
int		jitter_wr_cnt;
int		jitter_wr_pnt;

char		ptt;

//char		hole_punch_msg_sw;

int		fifo_hold_limit;

#ifdef		_SPECIFICATION_CHECK
char		voice_packet_save[15];
#endif

unsigned char	MD5_dmonitor[32];

#define		ICOM	0x00
#define		DVAP	0x01
#define		DVMEGA	0x02
#define		NODE	0x03

char	rig_type;

char	dvap_first_voice_pkt;

time_t	dest_keep_alive_send_time;
int	dest_keep_alive_cnt;

unsigned char	short_msg[21];
unsigned char	mini_header;
unsigned char	data_temp[5];

int	reboot_sw;
int	shutdown_sw;


unsigned char	used_call[8];
unsigned char	used_call2[4];
char	not_clear_error_msg;

unsigned char	alt_header[41];
int		alt_header_pnt;

int		gw_on;

char	cmd[256];
unsigned char   recvBuff[256];
int	code_sq;

unsigned char	msg_temp[21];
unsigned char	mycall2[4];
char	send_msg_sw;

unsigned char	rig_buff[1024];

/* DVMEGA */
long int 	dvmega_rxFrequency;
long int 	dvmega_txFrequency;
long int	dvmega_Frequency;
unsigned int 	dvmega_power;
int	m_rxDCOffset;
int	m_txDCOffset;
long int	dvmega_txOffset;
long int        dvmega_rxOffset;
float		dvmega_rxLevel;
float		dvmega_txLevel;
unsigned char	dvmega_tx_delay;
unsigned int	dvmega_dstarSpace;
char	dvmega_tx;
unsigned char	dvmega_mode;
unsigned char	rig_device[32];
unsigned char  	dvmega_frame_seq;


/* node adapter */
int     node_VenderID;
int     node_ProductID;
usb_dev_handle *udev;
struct  timeval NodeCosOffTime;
int	HeaderLength;
int	voice_pnt;
struct  usb_bus *bus;
struct  usb_device      *dev;

char	node_status;

int	node_tx_delay;

union
{
        struct  dv_header       node_hdr;
        char    buffer[41];
} usb;

struct	dv_packet	node_pkt;
struct  dv_packet       node_pkt_header;

char	node_voice_save[24];
int	node_tx_inv;
int	node_rx_inv;
int	node_voice_send_sw;

char	node_last_frame_sw;

int	beep_sw;
unsigned char	my_call[8];
int	scan_stop_sw;

/* LCD */
#define		NONE		0
#define		LCD_20x4	1
#define		LCD_16x2	2

int	lcd_type;
int	lcd;
time_t	lcd_time_save;

/* misc */
char	voice_packet_save[15];
int	hole_punchd_recvd;
int	send_header_sw;
time_t	msg_send_set_time;
int	unlink_sw;
int	no_cmd_sw;
int	used_call_sw;
long int	l_int;	
