#include	<stdio.h>
#include	<sys/types.h>
#include	<sys/socket.h>
#include	<netinet/in.h>
#include	<string.h>
#include	<sys/time.h>
#include	<unistd.h>
#include	<stdlib.h>
#include	<sys/utsname.h>
#include	<signal.h>
#include	<sys/select.h>
#include	<netinet/tcp.h>
#include	<netinet/in.h>
#include	<arpa/inet.h>
#include	<errno.h>
#include	<netdb.h>
#include	<time.h>
#include	<ctype.h>
#include	<fcntl.h>
#include	<termios.h>
#include	<linux/tty.h>
#include	<sys/ioctl.h>
#include	<net/if.h>
#include	<sys/select.h>
#include	<syslog.h>
#include	<sys/stat.h>
#include	<wiringPi.h>
#include	<lcd.h>
#include	<openssl/md5.h>
#include	<usb.h>
#include	"dstar.h"
#include	"node.h"
#include	"config.h"

//#define		_DEBUG_DVAP
//#define		_DEBUG_DVMEGA
//#define		_SPECIFICATIO_CHECK
//#define		_DEBUG_DVAP_SEND
//#define		_DEBUG_DVAP_RECV
//#define		_DEBUG_DVAP_SQUELCH
//#define		_DEBUG_JITTER
//#define		_DEBUG_INET

#define		GW	0x80
#define		ZR	0x40
#define		FWD	0x04
#define		XCHANGE	0x08


#define		HOLE_PUNCHD_SERVER	"hole-punchd.d-star.info"
#define		HOLE_PUNCHD_PORT	30010

#define		KEEP_ALIVE_INTERVAL	2

#define		CONNECTED_LIST		"/var/tmp/connected_table.html"	
#define         CONNECTED_LIST_TEMP     "/var/tmp/connected_table.temp"	
#define		ERROR_MSG		"/var/tmp/error_msg.html"
#define		ERROR_TEMP		"/var/tmp/error_msg.tmp"
#define		SHORT_MSG		"/var/tmp/short_msg.html"
#define		SHORT_TEMP		"/var/tmp/short_msg.tmp"
#define		BUFF_HOLD		"/var/www/buff_hold.txt"
#define		DVAP_CONF		"/var/www/dvap.conf"
#define		DVMEGA_CONF		"/var/www/dvmega.conf"
#define         NODE_CONF         	"/var/www/node.conf"
#define		RIG_DEVICE		"/dev/dstar"
#define		DMONITOR_FILE		"/var/www/dmonitor.conf"
#define		IDxxPlus_SPEED  	B38400
#define         DVAP_SPEED      	B230400
#define		DVMEGA_SPEED		B115200

#define		RIG_LED		19
#define		INET_LED	26

#define		PID_FILE		"/var/run/dmonitor.pid"

#define		SRC_INET_PORT	51000

#define		HOLE_PUNCH_SEND_INTERVAL 	2

#define		OS_RELEASE	"/etc/os-release"
#define		CODENAME	"buster"

void	drop_rate_print (void);
void	rig_fifo_check (void);

extern int	sig_term;

extern sigset_t	save_sig;
extern sigset_t	sigset;

extern fd_set	read_set;
extern fd_set	fd_save;

extern time_t	start_time;
extern time_t	cur_time;
extern struct	timespec	timeout;

extern struct	sockaddr_in	in_addr;
extern int	in_addr_sock;

extern struct	sockaddr_in	out_addr;

extern int	rig_fd;
extern struct	termios	save_attr;
extern struct	termios	attr;

extern time_t	send_time;

extern time_t	rig_alive_recv;

extern int	rig_buff_pnt;
extern int	rig_buff_next;

extern int	dest_inet_port;
extern char	*dest_address;
extern char	inet_send_buff[58];
extern int	m_seq;
extern int	frameID;
extern char	area_call[8];
extern char	zone_call[8];
extern int	send_sw;

extern int	hole_punch_port;
extern char	hole_punch_server[128];

extern unsigned char	inet_frame_id[2];
extern unsigned char	inet_frame_id_save[2];
extern struct	timeval	inet_recv_time;
extern struct	timeval	inet_recv_time_save;
extern struct	timeval	inet_recv_timeout;

extern struct	timeval		rig_last_timeout;
extern int	seq;
extern unsigned char send_buff[128];

extern unsigned char	inet_posit_buff[26];

extern time_t	rig_init_time;
extern int	scan_sw;
extern int	no_daemon;
extern struct	timeval	inet_time;
extern struct	timeval c_time;

extern struct  timeval rig_send_time;

extern char	header_save[42];

extern int	rig_send_sw;
extern int	LastFrameID;

extern FILE	*status_fd;

struct  FifoPkt
{
        struct  FifoPkt *next;
        int     length;
        unsigned char pkt[1024];
};

extern struct  FifoPkt *Rp;
extern struct  FifoPkt *Wp;
extern int     Fifo_cnt;
extern unsigned char recv_frame_seq;
extern int	fifo_hold;
extern int	fifo_new_hold;
extern int	rig_last_frame_send;

extern int	inet_led_sw;
extern int	rig_led_sw;

extern time_t	hole_punch_send_time;
extern int     hole_punch_send_cnt;
extern int	hole_punch_send_interval;

extern char	connect_call[8];

extern FILE	*connected_fd;

extern int	error_msg_sw;

extern unsigned int	inet_m;
extern unsigned int	inet_m_save;

extern long int	inet_read_cnt;
extern long int	inet_read_drop_cnt;

extern long int	jitter_max;
extern long int	jitter_min;
extern long int	jitter_ave;

extern unsigned char	jitter_buff[21][13];
extern int		jitter_rd_pnt;
extern int		jitter_wr_cnt;
extern int		jitter_wr_pnt;

extern char		ptt;

//char		hole_punch_msg_sw;

extern int		fifo_hold_limit;

#ifdef		_SPECIFICATION_CHECK
extern char		voice_packet_save[15];
#endif

extern unsigned char	MD5_dmonitor[32];

#define		ICOM	0x00
#define		DVAP	0x01
#define		DVMEGA	0x02
#define		NODE	0x03

extern char	rig_type;

extern char	dvap_first_voice_pkt;

extern time_t	dest_keep_alive_send_time;
extern int	dest_keep_alive_cnt;

extern unsigned char	short_msg[21];
extern unsigned char	mini_header;
extern unsigned char	data_temp[5];

extern int	reboot_sw;
extern int	shutdown_sw;


extern unsigned char	used_call[8];
extern unsigned char	used_call2[4];
extern char	not_clear_error_msg;

extern unsigned char	alt_header[41];
extern int		alt_header_pnt;

extern int		gw_on;

extern char	cmd[256];
extern unsigned char   recvBuff[256];
extern int	code_sq;

extern unsigned char	msg_temp[21];
extern unsigned char	mycall2[4];
extern char	send_msg_sw;

extern unsigned char	rig_buff[1024];

/* DVMEGA */
extern long int 	dvmega_rxFrequency;
extern long int 	dvmega_txFrequency;
extern long int	dvmega_Frequency;
extern unsigned int 	dvmega_power;
extern int	m_rxDCOffset;
extern int	m_txDCOffset;
extern long int	dvmega_txOffset;
extern long int        dvmega_rxOffset;
extern float		dvmega_rxLevel;
extern float		dvmega_txLevel;
extern unsigned char	dvmega_tx_delay;
extern unsigned int	dvmega_dstarSpace;
extern char	dvmega_tx;
extern unsigned char	dvmega_mode;
extern unsigned char	rig_device[32];
extern unsigned char  	dvmega_frame_seq;


/* node adapter */
extern int     node_VenderID;
extern int     node_ProductID;
extern usb_dev_handle *udev;
extern struct  timeval NodeCosOffTime;
extern int	HeaderLength;
extern int	voice_pnt;
extern struct  usb_bus *bus;
extern struct  usb_device      *dev;

extern char	node_status;

extern int	node_tx_delay;

union
{
        struct  dv_header       node_hdr;
        char    buffer[41];
} extern usb;

extern struct	dv_packet	node_pkt;
extern struct  dv_packet       node_pkt_header;

extern char	node_voice_save[24];
extern int	node_tx_inv;
extern int	node_rx_inv;
extern int	node_voice_send_sw;

extern char	node_last_frame_sw;

extern int	beep_sw;
extern unsigned char	my_call[8];
extern int	scan_stop_sw;

/* LCD */
#define		NONE		0
#define		LCD_20x4	1
#define		LCD_16x2	2

extern int	lcd_type;
extern int	lcd;
extern time_t	lcd_time_save;

/* misc */
extern char	voice_packet_save[15];
extern int	hole_punchd_recvd;
extern int	send_header_sw;
extern time_t	msg_send_set_time;
extern int	unlink_sw;
extern int	no_cmd_sw;
extern int	used_call_sw;
extern long int	l_int;	
